<?php
/**
 * @author          jtotal <support@jtotal.org>
 * @link            https://jtotal.org
 * @copyright       Copyright © 2020 JTOTAL All Rights Reserved
 * @license         GNU GPLv3 <http://www.gnu.org/licenses/gpl.html> or later
 */

defined('_JEXEC') or die;
use Joomla\CMS\Factory;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Installer\Installer;

/**
 * JT framework installer class
 */
class pkg_jtmapInstallerScript
{

   public $minJtfwVersion = '4.0.38';


   public function preflight()
    {

        $lang = Factory::getApplication()->getLanguage();
        $lang->load('plg_system_jtframework', JPATH_BASE);

        if (!$this->jtfwInstalled()) {
            $app = Factory::getApplication();
            $app->enqueueMessage(Text::_('JT framework required. Please, <a target="_blank" href="https://users.jtotal.org/SOFT/framework/JTframework/jtframework_v4_current.zip">download at jtotal.org</a> and install it before.'), 'error');
            return false;
        }else{
            return true;
			//check old framework update
			//$this->checkOldFrameworkUpdate();

		}
    }



    public function jtfwInstalled()
    {
        if (!is_file(JPATH_PLUGINS . '/system/jtframework/autoload.php')) {
            return false;
        }

        $plugin_file = JPATH_PLUGINS . '/system/jtframework/jtframework.xml';
        $plugin_data = simplexml_load_file($plugin_file);

        $xml = Installer::parseXMLInstallFile($plugin_file);

        if (!$xml || !isset($xml['version'])) {
            $app = Factory::getApplication();
            $app->enqueueMessage("JT framework corrupt. Please, reinstall it.", 'error');
            return false;
        }

        if (version_compare($xml['version'], $this->minJtfwVersion, '<')) {
            $app = Factory::getApplication();
            $app->enqueueMessage("JT framework version is too old. Please, update it.", 'error');
            return false;
        }

        return true;
    }


}
