var map;
function initAppleMap() {

    //var equivalentZoom = [0.0001,0.001,0.005,0.01,0.02,0.04,0.07,0.1,0.2,0.5,1,2,4,8,10,12,14,16,20,24,28,30];
    var equivalentZoom = [          
        100,
        80,
        70,
        60,
        24,
        14,
        8,
        5,
        2,
        1,
        0.5,
        0.2,
        0.08,
        0.06,
        0.04,
        0.02,
        0.01,
        0.005,
        0.002,
        0.001,
        0.0005
    ];

    var div = document.querySelector('#map_canvas');
    div.style.height = '400px';
    div.style.width = '100%';
    div.style.background = '#321654';

    mapkit.init({
        authorizationCallback: function (done) {
            done(mapkitToken);
        }
    });
 
    const center = new mapkit.Coordinate(parseFloat(jtLat), parseFloat(jtLon));

    span = new mapkit.CoordinateSpan(parseFloat(mapkitZoom),parseFloat(mapkitZoom)),
    region = new mapkit.CoordinateRegion(center, span);


    var mapOptions = {
        center: center,
        region: region,
        showScale:true,
        tintColor: "#123456",
        showsCompass: mapkit.FeatureVisibility.Hidden
    }

    map = new mapkit.Map("map_canvas", mapOptions);
    map.setRegionAnimated(region);


    var marker = new mapkit.MarkerAnnotation(map.center, {
        draggable: true,
        selected: true
    });
    map.addAnnotation(marker);



    marker.addEventListener("drag-start", function(event) {
        // No need to show "Drag me" message once user has dragged
        event.target.title = "";
    });
    marker.addEventListener("drag-end", function() {
        // Center the loupe on the marker's new location
        zoomedMap.setCenterAnimated(marker.coordinate);
    });



    div.addEventListener("click", function(event,listener) {

        event.preventDefault();
        var domPoint = new DOMPoint(); domPoint.x = event.pageX; domPoint.y = event.pageY;


        // Con el punto donde hemos hecho click se lo
        // pasamos al mapa para que nos de las coordenadas
        let coordinate = map.convertPointOnPageToCoordinate(domPoint);
        
        //let center = new mapkit.Coordinate(parseFloat(jtLat), parseFloat(jtLon));
        //let span = new mapkit.CoordinateSpan(map.span);
        //let region = new mapkit.CoordinateRegion(center, map.span);
        //map.setRegionAnimated(region);

        document.getElementById('jform_attribs_latitude').value = coordinate.latitude; document.getElementById('jform_attribs_longitude').value = coordinate.longitude;
        marker.coordinate = coordinate;
        map.setCenterAnimated (coordinate);

    });


    //CHANGE ZOOM
    jQuery('#jform_attribs_jtmap_zoom,#jform_attribs_jtmap_zoom_input').on('change', function () {

        let newlat = document.getElementById('jform_attribs_latitude').value;
        let newlon = document.getElementById('jform_attribs_longitude').value;
        
            var newCenter = new mapkit.Coordinate(parseFloat(newlat), parseFloat(newlon));
            var span = new mapkit.CoordinateSpan(equivalentZoom[document.getElementById('jform_attribs_jtmap_zoom').value]);
            var region = new mapkit.CoordinateRegion(newCenter, span);
            map.setRegionAnimated(region);
            
    });

    /*

    var pdiCoordinate = new mapkit.Coordinate(parseFloat(jtLat), parseFloat(jtLon));
    var pdiMarker = mapkit.MarkerAnnotation;
        // Setting properties on creation:
        var pdiAnnotation = new pdiMarker(pdiCoordinate);

        pdiAnnotation.color = '#f4a56d';
        pdiAnnotation.draggable = true;
        pdiAnnotation.selected= true;


        //map.showItems([pdiAnnotation]); 
        map.addAnnotation(pdiAnnotation);

  
        div.addEventListener("click", function(event,listener) {
            return;
            event.preventDefault();
            var domPoint = new DOMPoint(); domPoint.x = event.pageX; domPoint.y = event.pageY;

            // Con el punto donde hemos hecho click se lo
            // pasamos al mapa para que nos de las coordenadas
            let coordinate = map.convertPointOnPageToCoordinate(domPoint);
            
            let center = new mapkit.Coordinate(parseFloat(jtLat), parseFloat(jtLon));
            let span = new mapkit.CoordinateSpan(parseFloat(mapkitZoom),parseFloat(mapkitZoom));
            let region = new mapkit.CoordinateRegion(center, span);
            map.setRegionAnimated(region);

            document.getElementById('jform_attribs_latitude').value = coordinate.latitude; document.getElementById('jform_attribs_longitude').value = coordinate.longitude;
            pdiAnnotation.coordinate = coordinate;

        });
 
        pdiAnnotation.addEventListener("drag-start", function(event) {
            return;
            var domPoint = new DOMPoint(); domPoint.x = event.pageX; domPoint.y = event.pageY;

            let coordinate = map.convertPointOnPageToCoordinate(domPoint);

            document.getElementById('jform_attribs_latitude').value = coordinate.latitude; document.getElementById('jform_attribs_longitude').value = coordinate.longitude;
            pdiAnnotation.coordinate = coordinate;
           
           console.log(event);
        });
        */
       

        return;




    jQuery('#jform_attribs_jtmap_zoom_range').on('change', function () {

        var newCenter = new mapkit.Coordinate(37.792446, -122.399360);
        var span = new mapkit.CoordinateSpan(.01);
        var region = new mapkit.CoordinateRegion(newCenter, span);
        map.setRegionAnimated(region)
    });





    //CHANGE ICON
    jQuery('#jform_attribs_icon').on('change', function () {
        jtmapchange();
    });

    jQuery('#jform_attribs_ico_w,#jform_attribs_ico_h').on('change', function () {
        jtmapchange();
    });

    jQuery('#jform_attribs_custom_icon').on('change', function () {
        jtmapchange();
    });

    function jtmapchange() {

        var v_icon = jQuery('#jform_attribs_icon').val();

        if (v_icon == '') v_icon = 'map-marker-solid';

        var v_custom_icon = jQuery('#jform_attribs_custom_icon').val();

        var v_w = jQuery('#jform_attribs_ico_w').val();
        var v_h = jQuery('#jform_attribs_ico_h').val();

        if (v_icon == 'custom') {
            icon.url = f_custom_icon_base + v_custom_icon;
        } else {
            icon.url = f_icon_base + v_icon + '.svg';
        }

        icon.scaledSize = new google.maps.Size(v_w, v_h);
        marker.setIcon(icon);

    }
}