/**
 * 
 * 		//JTMAPS BACKEND
 * 
*/

var jtmapGmap;
var mapInitialized = false;
var icon = {
    url: jtmaps_gcat_params.icon_path
}
var marker;
function initMap() {
    if(mapInitialized) return;
    mapInitialized = true;
    var div = document.createElement('div');
    div.setAttribute('id','gmap');
    div.style.height = '400px';
    div.style.width = '100%';

    const mapCanvas = document.getElementById('map_canvas');
    mapCanvas.appendChild(div);

    var centro = {lat: jtmaps_gcat_params.lat_center , lng: jtmaps_gcat_params.long_center};

    jtmapGmap = new google.maps.Map(document.getElementById('gmap'), {
        center: centro,
        zoom: jtmaps_gcat_params.zoom
    });

    icon.scaledSize = new google.maps.Size(jtmaps_gcat_params.icon_size_w, jtmaps_gcat_params.icon_size_h);

    marker = new google.maps.Marker({
        position: centro,
        map: jtmapGmap,
        icon: icon,
        draggable:true
    });

    //DRAG
    marker.addListener('dragend', function(event) {

        jtmapGmap.panTo(this.getPosition());

        document.getElementById('jform_attribs_latitude').value = this.getPosition().lat();
        document.getElementById('jform_attribs_longitude').value = this.getPosition().lng();

    });

    // CHANGE ZOOM
    document.getElementById('jform_attribs_jtmap_zoom').addEventListener('change', function () {
        jtmapGmap.setZoom(Number(document.getElementById('jform_attribs_jtmap_zoom').value));
    });
}
/* 
    document.getElementById('jform_attribs_jtmap_zoom_range').addEventListener('change', function () {
        map.setZoom(Number(document.getElementById('jform_attribs_jtmap_zoom').value));
    });  */

// CHANGE ICON
document.getElementById('jform_attribs_icon').addEventListener('change', jtmapchange);

document.getElementById('jform_attribs_ico_w').addEventListener('change', jtmapchange);
document.getElementById('jform_attribs_ico_h').addEventListener('change', jtmapchange);

document.getElementById('jform_attribs_custom_icon').addEventListener('change', jtmapchange);


async function jtmapchange(){
    if(!mapInitialized){
        try {
            await jtmaploadScriptMap();
            jtmapchangeExect();
          } catch (error) {
            console.error('Error loading map script:', error);
        }
    }else{
        jtmapchangeExect();
    }
}


function jtmapchangeExect(){
   
    var v_icon = document.getElementById('jform_attribs_icon').value;

    if(v_icon == '') v_icon = 'map-marker-solid';

    var v_custom_icon = document.getElementById('jform_attribs_custom_icon').value;

    var v_w = parseInt(document.getElementById('jform_attribs_ico_w').value, 10);
    var v_h = parseInt(document.getElementById('jform_attribs_ico_h').value, 10);
    

    if(v_icon == 'custom'){
        icon.url = jtmaps_gcat_params.f_custom_icon_base+v_custom_icon;
    }else{
        icon.url = jtmaps_gcat_params.f_icon_base+v_icon+'.svg';

    }

    icon.scaledSize = new google.maps.Size(v_w,v_h);
    marker.setIcon(icon);


}


function jtmaploadScriptMap() {
    if(mapInitialized) return;
    return new Promise((resolve, reject) => {
        var url = jtmaps_gcat_params.gapi_url+'&callback=initMap';
        var script = document.createElement('script');
        script.src = url;
        script.defer = true;
        script.async = true;

        script.onload = function() {
        resolve();  // Resuelve la Promesa cuando el script se carga correctamente
        };

        script.onerror = function() {
        reject(new Error('Error loading Google Maps API script.'));
        };

        document.head.appendChild(script);
    });
}




