/**
 * 
 * 		//JTMAPS
 * 
 */

document.addEventListener('DOMContentLoaded', function() {
	jtmap_init();
});

function jtmap_init(){

	var jtmapContainer = document.getElementById('jtmap_container');
	var contentCategory = document.querySelector(jtmaps_gcat_params.jtmap_container);

	//BEFORE
	if(jtmaps_gcat_params.jtmap_insert_position == 'before'){
		contentCategory.insertBefore(jtmapContainer, contentCategory.firstChild);
	}
	//AFTER
	if(jtmaps_gcat_params.jtmap_insert_position == 'after'){
		contentCategory.insertAdjacentElement('afterend', jtmapContainer);
	}

	/*
	var markers = [];
	var directionDisplay;
	var directionsService;
	var stepDisplay;
	var map;
	*/

	//CLUSTERING
	loadGMapScript();
}


function initMap() {

	const myLatlng = new google.maps.LatLng(jtmaps_gcat_params.lat_center, jtmaps_gcat_params.long_center);
	
	const myOptions = {
		zoom: 10,
		center: myLatlng,
		mapTypeId: jtmaps_gcat_params.jtmap_cat_type,
		mapTypeControl: true
	}

	map = new google.maps.Map(document.getElementById("map_canvas"),myOptions);

	const labels = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';

   	var iconBase = '';
           
   	/////////////////////////////////////
   	/////////////////////////////////////
   	/////////     MARKERS    ////////////
   	/////////////////////////////////////
   	/////////////////////////////////////

   	var bounds = new google.maps.LatLngBounds();

	var markers = jtmaps_gcat_params.pois.map(function(poi, i) {
		var icon = {
			url: iconBase+poi.icon,
			scaledSize: new google.maps.Size(poi.icon_w,poi.icon_h)
		}

		var marker = new google.maps.Marker({
			position: {lat: poi.lat, lng: poi.long},
			icon: icon,
		});

		var contentString = '<div id="jtmarker">'+
			//'<div id="siteNotice">'+'</div>'+
			'<h3 class="jtmarker_title">'+poi.link+'</h3>'+
			'<div class="jtmap_content">'+
			'<p>'+poi.intro+'</p>'+
			poi.readmore+
			'<p>'+poi.address_topoi+'</p>'+			
			'</div>'+
			'</div>';


		var infowindow = new google.maps.InfoWindow({
			content: contentString
		});

		marker.addListener('click', function() {
			infowindow.open(map, marker);
		});

		//modify map to fit markers
		var latlong = new google.maps.LatLng(poi.lat, poi.long);
		bounds.extend(latlong);
		map.fitBounds(bounds);

		return marker;
	});

	/////////////////////////////////////
	/////////     CLUSTER    ////////////
	/////////////////////////////////////
	var markerCluster = new MarkerClusterer(map,markers,{imagePath: jtmaps_gcat_params.jtmapmedia+'markerclusterer/m'});
	var cluster = new MarkerClusterer(map,markers,{imagePath: jtmaps_gcat_params.jtmapmedia+'markerclusterer/m'});  

}




function setMarkers(map, locations) {
	var bounds = new google.maps.LatLngBounds();
	for (var i = 0; i < locations.length; i++) {
		var beach = locations[i];
		var myLatLng = new google.maps.LatLng(beach[1], beach[2]);

		bounds.extend(myLatLng);
		map.fitBounds(bounds);
	}

}

function loadGMapScript(){
	(function(d){
	var f = d.getElementsByTagName('SCRIPT')[0], p = d.createElement('SCRIPT');
	p.type = 'text/javascript';
	p.async = true;
	p.src = "//maps.google.com/maps/api/js?key="+jtmaps_gcat_params.gapi+"&amp;language="+jtmaps_gcat_params.locale+"&callback=initMap";
	f.parentNode.insertBefore(p, f);
	}(document));
}




