<?php
/**
 * @author          jtotal <support@jtotal.org>
 * @link            https://jtotal.org
 * @copyright       Copyright © 2020 JTOTAL All Rights Reserved
 * @license         GNU GPLv3 <http://www.gnu.org/licenses/gpl.html> or later
*/

defined('_JEXEC') or die;
use Joomla\CMS\Factory;
use Joomla\CMS\Language\Text;

require_once __DIR__ . '/script.install.helper.php';




class PlgSystemJtmapInstallerScript extends PlgSystemJtmapInstallerScriptHelper
{
	public $name = 'JT maps | system';
	public $alias = 'jtmap';
	public $extension_type = 'plugin';
    public $plugin_folder  = 'system';
	
	
	public function onBeforeInstall()
	{

	
        if(!$this->jtfwInstalled())
		{
            $app = Factory::getApplication();
			$app->enqueueMessage(Text::_('JT framework required. Please, <a target="_blank" href="https://users.jtotal.org/SOFT/framework/JTframework/pkg_jtfw_current.zip">download at jtotal.org</a> and install it before.'), 'error');
			return false;
		}
	}
}
