<?php
/**
 * @Copyright Copyright (C) 2023 jtotal.org All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * @link https://jtotal.org
 */
namespace Jtotal\Plugin\System\Jtmap\Extension;

use Joomla\CMS\Categories\Categories;
use Joomla\CMS\Factory;
use Joomla\CMS\Plugin\CMSPlugin;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\Registry\Registry;

// no direct access
defined('_JEXEC') or die;

class Jtmap extends CMSPlugin
{

    public function onBeforeRender()
    {

        $isAdministrator = Factory::getApplication()->isClient('administrator');
        if ($isAdministrator) {
            return;
        }

        $app = Factory::getApplication();
        $jinput = Factory::getApplication()->input;

        $catId = $jinput->get('id', '');

        if (empty($catId)) {
            return;
        }

        //CATEGORY
        if (in_array($jinput->get('option', ''), array('com_categories', 'com_content')) &&
            in_array($jinput->get('view', ''), array('categories', 'category'))) {

            $pluginParams = new Registry(PluginHelper::getPlugin('content', 'jtmap')->params);
            $jtmap_category_params = new Registry($pluginParams->get('jtmap_category_params', array()));

            if ($pluginParams->get('jtmap_cat_on', 0)) {

                if ($pluginParams->get('jtmap_debug', 0) == 1 || $pluginParams->get('jtmap_loading', 'default') == 'default') {
                    $doc = Factory::getDocument();
                    $wa = $doc->getWebAssetManager();
                    $wa->getRegistry()->addExtensionRegistryFile('plg_content_jtmap');

                    //USE CUSTOMS from category
                    /*
                    if ($jtmapcat_params->get('jtmap_category_usecustoms', '0') == '1') {

                    $cat_mapcontainer = $cat_map_params->get('map_container', $cat_mapcontainer);
                    $cat_maptype = $cat_map_params->get('maptype', $cat_maptype);
                    $cat_annotationtype = $cat_map_params->get('annotationtype', $cat_annotationtype);
                    $zoom = $cat_map_params->get('jtmap_zoom', $zoom);
                    $catwidth = $cat_map_params->get('catwidth', $catwidth);
                    $catheight = $cat_map_params->get('catheight', $catheight);
                    }
                     */

                    $categories = Categories::getInstance("content", array("access" => false, "published" => 0));
                    $jtmapcat_params = new Registry($categories->get($catId)->params);

                    $jtmap_category_customs = new Registry($jtmapcat_params->get('jtmap_category_customs', array()));

                    $mapType = ($jtmapcat_params->get('jtmap_category_usecustoms', '0') == '1') ?
                    $jtmap_category_customs->get('jtmap_use_map', $jtmap_category_params->get('jtmap_use_map', 'gmap')) :
                    $jtmap_category_params->get('jtmap_use_map', 'gmap');

                    // load AMAP
                    if ($mapType == 'amap') {
                        $wa->useScript('mapkit.js');
                        $wa->useScript('jtmap_amaps_category.js');
                    }

                    if ($mapType == 'gmap') {
                        //$wa->useScript('mapkit.js');
                        $wa->useScript('jtmap_gmaps_category.js');
                    }
                }
            }
        }
    }

    public function onAfterRender()
    {


/*         $isAdministrator = Factory::getApplication()->isClient('administrator');
        if ($isAdministrator) {
            return;
        } */

        $app = Factory::getApplication();
        $jinput = Factory::getApplication()->input;

        if (in_array($jinput->get('option', ''), array('com_categories', 'com_content')) &&
            in_array($jinput->get('view', ''), array('categories', 'category'))) {

            PluginHelper::importPlugin('content.jtmap');
            $data = Factory::getApplication()->triggerEvent('onCategoryDisplay', array('category', $jinput->get('id')));
        }

        if (isset($data) && !empty($data)) {
            $output = $app->getBody();
            //$output = WebApplication::getBody();
            $app->setBody(str_replace("</body>", implode("\n", $data) . "\n</body>", $output));
        }
    }
}
