<?php

/**
 * @package     JTMAP
 * @subpackage  jtmap
 *
 * @copyright   (C) 2023 jtotal
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
*/

namespace Jtotal\Plugin\Content\Jtmap\Fields;

use Joomla\CMS\Factory;
use Joomla\CMS\Form\FormField;
use Joomla\CMS\Language\Text;
use Jtotal\Jtfw\Helper\JtLicense;

defined('JPATH_PLATFORM') or die;

class JtCheckField extends FormField
{
    protected $type = 'JtCheck';

    protected function getLabel()
    {
        $mode = $this->element['mode'];
        if ($mode == 'dashboard') {
            return;
        }
    }

    protected function getInput()
    {
        $field_set = $this->form->getFieldset();
        $params = $this->form->getValue('params');

        $valida = JtLicense::_checkLicense();

        $field_value = '';

        if ($valida) {
            $field_value .= $this->pro();
        }

        if (!$valida) {
            $field_value .= $this->lite();
        }

        return $field_value;
    }

    private function lite()
    {

        JtLicense::disableFormsv4();

        $jinput = Factory::getApplication()->input;

        $module_id = $this->form->getValue('id');
        $params = $this->form->getValue('params');

        if ($params !== null) {
            //$this->form->setValue('pfeedcomments','0');
            $params->jtmap_loading = 'default';
            $params->show_openinmap_button = '0';
            $params->maptype = 'roadmap';
            $params->jtmap_trigger = 'before_display';
            $params->amap_design_colorscheme = 'light';
            $params->amap_design_tint = '#000000';
            $params->jtmap_cat_on = '0';
        } else {
            return $this->mensajeLITE();
        }

        //consulta
        $reparams = $this->form->getValue('params');

        $encode_params = json_encode($params);
        //var_dump($reparams);

        //$this->form->setValue('params', null, $params);

        $this->form->setValue('params', null, $params);

        $db = Factory::getDBO();
        $query = $db->getQuery(true);
        // Build the query
        $query->update($db->quoteName('#__extensions'));
        $query->set($db->quoteName('params') . ' = ' . $db->quote((string) $encode_params));
        $query->where($db->quoteName('element') . ' = ' . $db->quote("jtmap") . ' AND ' . $db->quoteName('folder') . ' = ' . $db->quote("content"));

        // Execute the query
        $db->setQuery($query);

        $db->execute();

        return $this->mensajeLITE();
    }

    private function pro()
    {
        $field_value = '';
        return $field_value;
    }

    private function mensajeLITE()
    {
        return '<div class="alert alert-info">' . Text::_('JT_FW_EXTENSIONS_SOME_VALUES_LITE') . '</div>';
    }
}
