<?php

/**
 * @package     JTMAP
 * @subpackage  jtmap
 *
 * @copyright   (C) 2023 jtotal
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

namespace Jtotal\Plugin\Content\Jtmap\Fields;

use Joomla\CMS\Factory;
use Joomla\CMS\Form\FormField;
use Joomla\CMS\Uri\Uri;
use Joomla\CMS\Version;

defined('JPATH_PLATFORM') or die;

class JtmapBackendField extends FormField
{
    protected $type = 'JtmapBackend';

    protected function getLabel()
    {

        return parent::getLabel();
        //return "<strong>License</strong>";
    }

    protected function getInput()
    {

        $field_set = $this->form->getFieldset();

        $document = Factory::getDocument();
        $plugin_path = Uri::root() . 'plugins/content/jtmap';

        $version = new Version();
        $jversion = substr($version->getShortVersion(), 0, 1);

        $document->addScriptdeclaration('var jversion="' . $jversion . '";');

        $field_value = '';

        return $field_value;
    }
}
