<?php

/**
 * @package     JTMAP
 * @subpackage  jtmap
 *
 * @copyright   (C) 2023 jtotal
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
*/

namespace Jtotal\Plugin\Content\Jtmap\Fields;

use Joomla\CMS\Form\Field\ListField;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\Registry\Registry;

defined('JPATH_PLATFORM') or die;

class JtmapSelectMapField extends ListField
{
    /**
     * The form field type.
     *
     * @var    string
     * @since  11.1
     */
    protected $type = 'JtmapSelectMap';

    protected function getLabel()
    {

        $this->label = isset($this->element['label']) ? (string) Text::_($this->element['label']) : '';
        //return $this->label;
        return $this->label;
    }

    protected function getInput()
    {

        $plugin = PluginHelper::getPlugin('content', 'jtmap');
        $plugin_params = new Registry($plugin->params);

        if ($this->value == '') {
            $this->value = $plugin_params->get('jtmap_default_map');
        }
        // Get the field options.
        $options = (array) $this->getOptions();

        return parent::getInput();
    }

    protected function getOptions()
    {

        $plugin = PluginHelper::getPlugin('content', 'jtmap');
        $plugin_params = new Registry($plugin->params);

        $mapas = array();

        foreach ($plugin_params->get('jtmap_use_map', array('gmap')) as $key => $value) {
            if ($value == 'gmap') {
                $text = 'Google Maps';
            } elseif ($value == 'amap') {
                $text = 'Apple Maps';
            } else {
                $text = 'Open Maps';
            }
            $mapas[] = Htmlhelper::_('select.option', $value, Text::_($text));
        }
        
        return $mapas;
    }
}
