<?php

/**
 * @package     JTMAP
 * @subpackage  jtmap
 *
 * @copyright   (C) 2023 jtotal
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
*/

namespace Jtotal\Plugin\Content\Jtmap\Fields;

use Joomla\CMS\Form\Field\ListField;
use Joomla\CMS\Language\Text;

defined('JPATH_PLATFORM') or die;

/**
 * Form Field class for the Joomla Platform.
 * Supports a generic list of options.
 *
 * @since  1.7.0
 */
class JtmapShowMapField extends ListField
{
    /**
     * The form field type.
     *
     * @var    string
     * @since  1.7.0
     */
    protected $type = 'JtmapShowMap';

    protected function getLabel()
    {
        return '&nbsp;';
    }

    /**
     * Method to get the field input markup for a generic list.
     * Use the multiple attribute to enable multiselect.
     *
     * @return  string  The field input markup.
     *
     * @since   3.7.0
     */
    protected function getInput()
    {

/*         $button = '<a  class="btn btn-success jtmapshowmapbutton" onclick="jtmaploadScriptMap();">
			<i class="fas fa-map-marked-alt"></i> ' . Text::_('PLG_JTMAP_SHOW_MAP') . '</a>';

        $button .= '<div id="map_canvas"></div>'; */

		$button = '<!-- Button trigger modal -->
		<button type="button" class="btn btn-primary" data-bs-toggle="modal" data-bs-target="#jtmapmodalmap" onclick="jtmaploadScriptMap();">
      <i class="fas fa-map-marked-alt"></i> ' . Text::_('PLG_JTMAP_SHOW_MAP') . '
		</button>
    <span class="jtmapshowmapbutton"><span>
		
		<!-- Modal -->
		<div class="modal fade" id="jtmapmodalmap" tabindex="-1" aria-labelledby="jtmapmodalmapLabel" aria-hidden="true">
		  <div class="modal-dialog modal-dialog-centered modal-lg">
			<div class="modal-content">
			  <div class="modal-header">
				<h1 class="modal-title fs-5" id="jtmapmodalmapLabel">JT Map</h1>
				<button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
			  </div>
			  <div class="modal-body">
			     <div id="map_canvas"></div>
			  </div>
			  <div class="modal-footer">
				<button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
			  </div>
			</div>
		  </div>
		</div>';


        return $button;
    }
}
